
	IMPLICIT none
	INTEGER	i,j,k,m,n,nsolute,nsolvent,n_new_sol
	REAL::	Solute(100,3), Solvent(1000,3),Solvated(1100,3)
	REAL::	Dimensions,dis_def
	CHARACTER(len=10)::JUNK
	ChARACTER(len=2)::ATOMSOLUTE(100),ATOMSOLVENT(1000)
	REAl:: 	Solv_n(1000,3),Solu_n(100,3),n_sol,D(1000,3)

	open(unit=1,file='solute.xyz',status='unknown')
	open(unit=2,file='solvent.xyz',status='unknown')
	open(unit=3,file='solvated.xyz',status='unknown')
	open(unit=4,file='new_solute.xyz',status='unknown')

	READ(1,*) nsolute
	READ(1,*) Dimensions, dis_def
	print *, "Dimensions Chosen: ", Dimensions
	print *, "Solute-Water Cutoff: ", dis_def
	READ(2,*) nsolvent
	READ(2,*) JUNK

C---	READ MOLECULAR COORDS --------------------------------

	CALL	ReadMol(nsolute,1,Solute,ATOMSOLUTE,100)
	CALL	ReadMol(nsolvent,2,Solvent,ATOMSOLVENT,1000)

C--	TRANSPOSE SOLUE TO CENTRE ----------------------------

	CALL 	COG(nsolute,Solute,Solu_n,Dimensions,100)

	DO i=1,nsolute
		WRITE(4,*) ATOMSOLUTE(i),Solu_n(i,1),Solu_n(i,2),
     .  Solu_n(i,3)
	ENDDO

C--	CUT WATER TO DIMENSIONS ------------------------------

	CALL 	WATER_BOX(nsolvent,Dimensions,Solvent,Solv_n,1000,
     .	n_new_sol)

C--	CHECK FOR CLOSE CONTACTS ------------------------------

	CALL 	CONTACTS(n_new_sol,nsolute,Solv_n,Solu_n,1000,100,
     .  D,n_sol,ATOMSOLVENT,dis_def)

	END
C-------------------------------------------------------------------------------

	SUBROUTINE CONTACTS(nsolv,nsolu,A,B,D1,D2,D,nsolv_n,ATMS,dis_def)

	INTEGER i,j,k,nsolv,nsolu,D1,D2,n_solv_n,CHK
	REAL::  A(D1,3),B(D2,3),C(D2,3),D(D1,3)
	REAL::  d_con,dis,dis_def
	CHARACTER(len=2)::ATMS(1000)

	d_con=3
	n_solv_n=0

	DO i=1,nsolv-2,3
	CHK=0
	DO j=1,nsolu

	dis=SQRT((A(i,1)-B(j,1))**2+(A(i,2)-B(j,2))**2+
     .	(A(i,3)-B(j,3))**2)
	IF(dis.LT.dis_def)THEN
		CHK=CHK+1
	ENDIF
	ENDDO
		IF(CHK.EQ.0)THEN
		D(n_solv_n+1,1)=A(i,1)
		D(n_solv_n+1,2)=A(i,2)
		D(n_solv_n+1,3)=A(i,3)
		D(n_solv_n+2,1)=A(i+1,1)
		D(n_solv_n+2,2)=A(i+1,2)
		D(n_solv_n+2,3)=A(i+1,3)
		D(n_solv_n+3,1)=A(i+2,1)
		D(n_solv_n+3,2)=A(i+2,2)
		D(n_solv_n+3,3)=A(i+2,3)

		n_solv_n=n_solv_n+3
		ENDIF


	ENDDO
	print *, "Number Of Waters Added: ", n_solv_n/3

	DO i=1,n_solv_n
	WRITE(3,*)  ATMS(i),D(i,1),D(i,2),D(i,3)
	ENDDO

	END SUBROUTINE


	SUBROUTINE ReadMol(n,IND,A,ATOM,D)

	INTEGER	i,j,k,n,IND,D
	REAL::	A(D,3)
	CHARACTER(len=2)::ATOM(1400)

	do i=1,n
		READ(IND,*) ATOM(i), A(i,1), A(i,2), A(i,3)
C		READ(IND,*) ATOM(i), A(i,2)

	enddo

	END SUBROUTINE

	SUBROUTINE	WATER_BOX(n,Dim,A,B,D,n_new_sol)

	

	INTEGER i,j,k,n,D,n_new_sol
	REAL::	A(D,3),B(D,3),cutoff,Dim
	REAL::	x,y,z

	cutoff=Dim-1.6
	n_new_sol=0
	DO i=1,n-2,3

		x=A(i,1)
		y=A(i,2)
		z=A(i,3)

		IF(x.LT.cutoff)THEN
		IF(y.LT.cutoff)THEN
		IF(z.LT.cutoff)THEN
		
			B(n_new_sol+1,1)=A(i,1)
			B(n_new_sol+1,2)=A(i,2)
			B(n_new_sol+1,3)=A(i,3)

			B(n_new_sol+1+1,1)=A(i+1,1)
			B(n_new_sol+1+1,2)=A(i+1,2)
			B(n_new_sol+1+1,3)=A(i+1,3)

			B(n_new_sol+1+2,1)=A(i+2,1)
			B(n_new_sol+1+2,2)=A(i+2,2)
			B(n_new_sol+1+2,3)=A(i+2,3)

			n_new_sol=n_new_sol+3
			
		ENDIF
		ENDIF
		ENDIF


	ENDDO
		DO i=1,n_new_sol
			A(i,1)=B(i,1)
			A(i,2)=B(i,2)
			A(i,3)=B(i,3)
		ENDDO

	END	SUBROUTINE

	SUBROUTINE WriteMol(n,IND,A,D)

	INTEGER	i,j,n,IND,D
	REAL::	A(D,3)
	print *, "ENTERIN WRITE"

	DO i=1,n
		WRITE(IND,*)(A(i,j), j=1,3) 
	ENDDO
	END SUBROUTINE



	SUBROUTINE COG(n,A,B,Dim,D)


	INTEGER i,j,k,n,D
	REAL::	Dim,A(D,3),B(D,3)
	REAL::	sX,sY,sZ,tX,tY,tZ
	REAL:: 	aX,aY,aZ

	sX=0
	tX=0
	sY=0
	tY=0
	sZ=0
	tZ=0

	DO i=1,n
		sX=sX+A(i,1)	
		sY=sY+A(i,2)	
		sZ=sZ+A(i,3)	
	ENDDO

		aX=sX/n
		aY=sY/n
		aZ=sZ/n

		tX=Dim/2-aX
		tY=Dim/2-aY
		tZ=Dim/2-aZ

	DO i=1,n

		B(i,1)=A(i,1)+tX
		B(i,2)=A(i,2)+tY
		B(i,3)=A(i,3)+tZ

	ENDDO
	DO i=1,n
		A(i,1)=B(i,1)
		A(i,2)=B(i,2)
		A(i,3)=B(i,3)
	ENDDO


	END	SUBROUTINE
